exports.up = function(knex) {
  return knex.schema.createTable('tenants', function(t) {
    t.increments('id')
      .unsigned()
      .primary()
      .notNullable();
    t.timestamps(false, true);
    t.string('hostname')
      .notNullable()
      .unique();
    t.string('entryPoint').notNullable();
    t.string('issuer').notNullable();
    t.string('cert').nullable();
    t.string('decryptionPvk').nullable();
    t.string('adminContact').nullable();
    t.string('settings').nullable();
  });
};

exports.down = function(knex) {
  // should we drop the entire table if we rollback? seems a bit dramatic...
  // return knex.schema.dropTable('tenants');
};
