const dbConfig = require('../knexfile')[process.env.NODE_ENV];
const knex = require('knex');
const sendReport = require('./util/sendReport');
const { service } = require('./util/service-layer');

const db = knex(dbConfig);

db.raw('select 1+1 as result')
  .then(() => service._logger.info('database connected'))
  .catch(error => {
    service._logger.error(
      'Issue arised when checking connection to the database. Please make sure your configuration is correct before moving forward'
    );
    sendReport(error);
  });

module.exports = db;
