const tenantCache = {};

// Function to shove tenant object into tenant cache
// If successful returns true
// Else returns false
function setTenantCache(tenant) {
  if (typeof tenant === 'object') {
    tenantCache[tenant.hostname] = Object.assign({}, tenant);
    return true;
  }
  return false;
}

// Function to get tenant object from the tenant cache using hostname value
// If tenant exists returns a COPY of the tenant object - this is important so any mutations do not affect original object
// Else return undefined
function getTenantCache(hostname) {
  const cachedTenant = tenantCache[hostname];
  if (typeof cachedTenant === 'object') {
    return Object.assign({}, cachedTenant);
  }
  return;
}

// Function to remove a tenant object from the cache
function deleteTenantCache(hostname) {
  delete tenantCache[hostname];
}

module.exports = {
  tenantCache,
  setTenantCache,
  getTenantCache,
  deleteTenantCache,
};
